﻿//UTF-8
using System;

namespace MsReport
{
    public partial class frmMain : System.Windows.Forms.Form
    {
        private const string CONNECTIONSTRING = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=.\Database.mdb;Persist Security Info=False";
        private const string SQLSELECT = "SELECT [ID_Key], [Caption] FROM [dtMain]";
        private const string XMLDATABASEFILENAME = "Database.xml";
        //////////////////////////////////////////////////////////////////////

        public frmMain()
        {
            this.InitializeComponent();
        }
        //////////////////////////////////////////////////////////////////////

        private void frmMain_Load(object sender, EventArgs e)
        {
            //Load...
            //this.LoadData_XML();
            this.LoadData_JET();

            //Set...
            this.MsRptView.LocalReport.DataSources.Add(new Microsoft.Reporting.WinForms.ReportDataSource( this.MsRptView.LocalReport.GetDataSourceNames()[0],this.dbDS.dtMain ));
            
            //Refresh...
            this.MsRptView.RefreshReport();
        }
        //////////////////////////////////////////////////////////////////////


        private void LoadData_XML()
        {
            //this.dbDS.Clear();
            this.dbDS.ReadXml(System.IO.Path.Combine(System.Windows.Forms.Application.StartupPath, XMLDATABASEFILENAME));
        }
        //////////////////////////////////////////////////////////////////////

        private void LoadData_JET()
        {
            //this.dbDS.Clear();
            using (System.Data.OleDb.OleDbDataAdapter dbDA = new System.Data.OleDb.OleDbDataAdapter(SQLSELECT, CONNECTIONSTRING))
            {
                dbDA.Fill(this.dbDS.dtMain);
            }
        }
        //////////////////////////////////////////////////////////////////////


        [System.STAThread()]public static void Main()
        {
            System.Windows.Forms.Application.EnableVisualStyles();
            System.Windows.Forms.Application.Run(new frmMain());
        }
        //////////////////////////////////////////////////////////////////////
    }
}
