﻿'UTF-8
Option Strict On

Public NotInheritable Class Main


    <System.STAThread()> Public Shared Sub Main()
        Dim c As New Main
        c.MsRPrint()
    End Sub




    Private m_Img As System.Drawing.Image

    Private Sub MsRPrint()
        Dim DataSource As New TDataSet.TDataTableDataTable

        DataSource.AddTDataTableRow(123, "Visual Studio.Net")
        DataSource.AddTDataTableRow(456, "Visual C++")
        DataSource.AddTDataTableRow(789, "Visual Basic.Net")


        Dim XML As String = _
             "<DeviceInfo>" & _
             " <OutputFormat>JPEG</OutputFormat>" & _
             " <PageWidth>8.26in</PageWidth>" & _
             " <PageHeight>11.69in</PageHeight>" & _
             " <DpiX>300</DpiX>" & _
             " <DpiY>300</DpiY>" & _
             " <StartPage>1</StartPage>" & _
             " <EndPage>1</EndPage>" & _
             "</DeviceInfo>"

        Dim imagebuffer() As Byte
        Using rpt As New Microsoft.Reporting.WinForms.LocalReport

            rpt.LoadReportDefinition(System.Reflection.Assembly.GetExecutingAssembly.GetManifestResourceStream("MsReport.MsReport.rdlc"))
            rpt.DataSources.Add(New Microsoft.Reporting.WinForms.ReportDataSource(rpt.GetDataSourceNames(0), DataSource))
            imagebuffer = rpt.Render("Image", XML, Nothing, Nothing, Nothing, Nothing, Nothing)
        End Using

        Using _
             mem As New System.IO.MemoryStream(imagebuffer, False), _
             img As System.Drawing.Image = System.Drawing.Image.FromStream(mem), _
             dp As New System.Drawing.Printing.PrintDocument

            Me.m_Img = img
            AddHandler dp.PrintPage, AddressOf Me.PrintPage

            'dp.PrinterSettings...

            dp.Print()
        End Using

    End Sub

    Private Sub PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        e.Graphics.DrawImage(Me.m_Img, 0, 0)
    End Sub

End Class
